Index: trunk/kernel/kern/thread.c
===================================================================
--- trunk/kernel/kern/thread.c	(revision 690)
+++ trunk/kernel/kern/thread.c	(revision 1)
@@ -933,9 +372,7 @@
 	hal_fpu_context_destroy( thread );
 	
-    // release user stack vseg (for an user thread only)
-    if( type == THREAD_USER )  vmm_remove_vseg( process , thread->user_stack_vseg );
-
-    // release FPU ownership if required
-	hal_disable_irq( &save_sr );
+    // release FPU if required
+    // TODO This should be done before calling thread_destroy()
+	hal_disable_irq( &state );
 	if( core->fpu_owner == thread )
 	{
@@ -943,604 +380,229 @@
 		hal_fpu_disable();
 	}
-	hal_restore_irq( save_sr );
-
+	hal_restore_irq( state );
+
+    // remove thread from process th_tbl[] 
+    // TODO This should be done before calling thread_destroy()
+    ltid_t ltid = LTID_FROM_TRDID( thread->trdid );
+
+	spinlock_lock( &process->th_lock );
+	process->th_tbl[ltid] = XPTR_NULL;
+	process->th_nr--;
+	spinlock_unlock( &process->th_lock );
+	
     // invalidate thread descriptor
 	thread->signature = 0;
 
-    // release memory for thread descriptor (including kernel stack)
-    kmem_free( thread , CONFIG_THREAD_DESC_ORDER );
-
-#if DEBUG_THREAD_DESTROY
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_DESTROY < cycle )
-printk("\n[%s] thread[%x,%x] exit / destroyed thread[%x,%x] / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, process->pid, thread->trdid, cycle );
-#endif
-
-    return count;
-
-}   // end thread_destroy()
-
-//////////////////////////////////////////////////
-inline void thread_set_req_ack( thread_t * target,
-                                uint32_t * rsp_count )
-{
-    reg_t    save_sr;   // for critical section
-
-    // get pointer on target thread scheduler
-    scheduler_t * sched = &target->core->scheduler;
-
-    // wait scheduler ready to handle a new request
-    while( sched->req_ack_pending ) asm volatile( "nop" );
+    // release memory for thread descriptor
+	kmem_req_t   req; 
+	req.type     = KMEM_PAGE; 
+	req.ptr      = ppm_base2page( thread );
+	kmem_free(&req);
+
+	tm_end = hal_time_stamp();
+
+	thread_dmsg("INFO : %s destroy thread %x for process %x on core %d in cluster %x\n"
+                 " / duration = %d / page_faults = %d / ticks = %d\n",
+	               __FUNCTION__, trdid , pid , core_lid , local_cxy ,
+	               tm_end - tm_start , pgfaults , ticks );
+
+}  // end thread_destroy()
+
+
+/////////////////////////////////////////////////
+void thread_child_parent_link( xptr_t  xp_parent,
+                               xptr_t  xp_child )
+{
+    // get extended pointers on children list root 
+    cxy_t      parent_cxy = GET_CXY( xp_parent );    
+    thread_t * parent_ptr = (thread_t *)GET_PTR( xp_parent );
+    xptr_t     root       = XPTR( parent_cxy , &parent_ptr->children_root );
+
+    // get extended pointer on children list entry 
+    cxy_t      child_cxy  = GET_CXY( xp_child );    
+    thread_t * child_ptr  = (thread_t *)GET_PTR( xp_child );
+    xptr_t     entry      = XPTR( child_cxy , &child_ptr->brothers_list );
+
+    // set the link
+    xlist_add_first( root , entry );
+    hal_remote_atomic_add( XPTR( parent_cxy , &parent_ptr->children_nr ) , 1 );
+} 
+
+///////////////////////////////////////////////////
+void thread_child_parent_unlink( xptr_t  xp_parent,
+                                 xptr_t  xp_child )
+{
+    // get extended pointer on children list lock
+    cxy_t      parent_cxy = GET_CXY( xp_parent );    
+    thread_t * parent_ptr = (thread_t *)GET_PTR( xp_parent );
+    xptr_t     lock       = XPTR( parent_cxy , &parent_ptr->children_lock );
+
+    // get extended pointer on children list entry 
+    cxy_t      child_cxy  = GET_CXY( xp_child );    
+    thread_t * child_ptr  = (thread_t *)GET_PTR( xp_child );
+    xptr_t     entry      = XPTR( child_cxy , &child_ptr->brothers_list );
+
+    // get the lock
+    remote_spinlock_lock( lock );
+
+    // remove the link
+    xlist_unlink( entry );
+    hal_remote_atomic_add( XPTR( parent_cxy , &parent_ptr->children_nr ) , -1 );
     
-    // enter critical section
-    hal_disable_irq( &save_sr );
-      
-    // set request in target thread scheduler
-    sched->req_ack_pending = true;
-
-    // set ack request in target thread "flags"
-    hal_atomic_or( &target->flags , THREAD_FLAG_REQ_ACK );
-
-    // set pointer on responses counter in target thread
-    target->ack_rsp_count = rsp_count;
-    
-    // exit critical section
-    hal_restore_irq( save_sr );
-
-    hal_fence();
-
-}  // thread_set_req_ack()
-
-/////////////////////////////////////////////////////
-inline void thread_reset_req_ack( thread_t * target )
-{
-    reg_t    save_sr;   // for critical section
-
-    // get pointer on target thread scheduler
-    scheduler_t * sched = &target->core->scheduler;
-
-    // check signal pending in scheduler
-    assert( __FUNCTION__, sched->req_ack_pending , "no pending signal" );
-    
-    // enter critical section
-    hal_disable_irq( &save_sr );
-      
-    // reset signal in scheduler
-    sched->req_ack_pending = false;
-
-    // reset signal in thread "flags"
-    hal_atomic_and( &target->flags , ~THREAD_FLAG_REQ_ACK );
-
-    // reset pointer on responses counter 
-    target->ack_rsp_count = NULL;
-    
-    // exit critical section
-    hal_restore_irq( save_sr );
-
-    hal_fence();
-
-}  // thread_reset_req_ack()
-
-//////////////////////////////////////
-void thread_block( xptr_t   thread_xp,
-                   uint32_t cause )
+    // release the lock
+    remote_spinlock_unlock( lock );
+}
+
+/////////////////////////////////////////////////
+inline void thread_set_signal( thread_t * thread,
+                               uint32_t   mask )
+{
+    hal_atomic_or( &thread->signals , mask );
+}
+ 
+///////////////////////////////////////////////////
+inline void thread_reset_signal( thread_t * thread,
+                                 uint32_t   mask )
+{
+    hal_atomic_and( &thread->signals , ~mask );
+}
+ 
+//////////////////////////////////
+inline bool_t thread_is_joinable()
+{
+    thread_t * this = CURRENT_THREAD;
+    return( (this->brothers_list.next != XPTR_NULL) &&
+            (this->brothers_list.pred != XPTR_NULL) );
+}
+
+//////////////////////////////////
+inline bool_t thread_is_runnable()
+{
+    thread_t * this = CURRENT_THREAD;
+    return( this->blocked == 0 );
+}
+
+////////////////////////////////
+inline bool_t thread_can_yield()
+{
+    thread_t * this = CURRENT_THREAD;
+    return ( (this->local_locks == 0) && (this->remote_locks == 0) );
+}
+
+///////////////////////////
+bool_t thread_check_sched()
+{
+	thread_t * this = CURRENT_THREAD;
+
+    // check locks count
+	if( (this->local_locks != 0) || (this->remote_locks != 0) ) return false;
+
+    // compute elapsed time, taking into account 32 bits register wrap
+    uint32_t elapsed;
+    uint32_t time_now   = hal_time_stamp();
+    uint32_t time_last  = this->time_last_check;
+    if( time_now < time_last ) elapsed = (0xFFFFFFFF - time_last) + time_now;
+	else                       elapsed = time_now - time_last;
+
+    // update thread time
+    this->time_last_check = time_now;
+
+	// check elapsed time
+	if( elapsed < CONFIG_CORE_CHECK_EVERY ) return false;
+    else                                    return true;
+}
+
+/////////////////////
+error_t thread_exit()
+{
+    uint32_t   sr_save;
+
+	thread_t * this = CURRENT_THREAD;
+
+    // test if this thread can be descheduled
+	if( !thread_can_yield() )
+	{
+        printk("ERROR in %s : thread %x in process %x on core %d in cluster %x\n"
+               " did not released all locks\n",
+               __FUNCTION__ , this->trdid , this->process->pid ,
+               CURRENT_CORE->lid , local_cxy );
+        return EINVAL;
+    }
+
+    if( this->flags & THREAD_FLAG_DETACHED )
+    {
+        // if detached set signal and set blocking cause atomically
+        hal_disable_irq( &sr_save );
+        thread_set_signal( this , THREAD_SIG_KILL );
+        thread_block( this , THREAD_BLOCKED_EXIT );
+        hal_restore_irq( sr_save );
+    }
+    else 
+    {
+        // if attached, set blocking cause 
+        thread_block( this , THREAD_BLOCKED_EXIT );
+    }
+
+    // deschedule
+    sched_yield();
+    return 0;
+
+} // end thread_exit()
+
+/////////////////////////////////////
+void thread_block( thread_t * thread,
+                   uint32_t   cause )
+{
+    // set blocking cause 
+    hal_atomic_or( &thread->blocked , cause );
+
+}  // end thread_block()
+
+////////////////////////////////////
+void thread_unblock( xptr_t   thread,
+                    uint32_t cause )
 {
     // get thread cluster and local pointer
-    cxy_t      cxy = GET_CXY( thread_xp );
-    thread_t * ptr = GET_PTR( thread_xp );
-
-    // set blocking cause
-    hal_remote_atomic_or( XPTR( cxy , &ptr->blocked ) , cause );
-    hal_fence();
-
-#if DEBUG_THREAD_BLOCK
-uint32_t    cycle   = (uint32_t)hal_get_cycles();
-process_t * process = hal_remote_lpt( XPTR( cxy , &ptr->process ) );
-thread_t  * this    = CURRENT_THREAD;
-if( DEBUG_THREAD_BLOCK < cycle )
-printk("\n[%s] thread[%x,%x] blocked thread %x in process %x / cause %x\n",
-__FUNCTION__, this->process->pid, this->trdid,
-ptr->trdid, hal_remote_l32(XPTR( cxy , &process->pid )), cause );
-#endif
-
-} // end thread_block()
-
-////////////////////////////////////////////
-uint32_t thread_unblock( xptr_t   thread_xp,
-                         uint32_t cause )
-{
-    // get thread cluster and local pointer
-    cxy_t      cxy = GET_CXY( thread_xp );
-    thread_t * ptr = GET_PTR( thread_xp );
+    cxy_t      cxy = GET_CXY( thread ); 
+    thread_t * ptr = (thread_t *)GET_PTR( thread );
 
     // reset blocking cause
-    uint32_t previous = hal_remote_atomic_and( XPTR( cxy , &ptr->blocked ) , ~cause );
-    hal_fence();
-
-#if DEBUG_THREAD_BLOCK
-uint32_t    cycle   = (uint32_t)hal_get_cycles();
-process_t * process = hal_remote_lpt( XPTR( cxy , &ptr->process ) );
-thread_t  * this    = CURRENT_THREAD;
-if( DEBUG_THREAD_BLOCK < cycle )
-printk("\n[%s] thread[%x,%x] unblocked thread %x in process %x / cause %x\n",
-__FUNCTION__, this->process->pid, this->trdid,
-ptr->trdid, hal_remote_l32(XPTR( cxy , &process->pid )), cause );
-#endif
-
-    // return a non zero value if the cause bit is modified 
-    return( previous & cause );
+    hal_remote_atomic_and( XPTR( cxy , &ptr->blocked ) , ~cause );
 
 }  // end thread_unblock()
 
-//////////////////////////////////////////////
-void thread_delete_request( xptr_t  target_xp,
-                            bool_t  is_forced )
-{
-    reg_t       save_sr;                // for critical section
-    bool_t      target_join_done;       // joining thread arrived first
-    bool_t      target_attached;        // target thread attached
-    xptr_t      killer_xp;              // extended pointer on killer thread (this)
-    thread_t  * killer_ptr;             // pointer on killer thread (this)
-    cxy_t       target_cxy;             // target thread cluster     
-    thread_t  * target_ptr;             // pointer on target thread
-    process_t * target_process;         // pointer on target process
-    pid_t       target_pid;             // target process identifier
-    xptr_t      target_flags_xp;        // extended pointer on target thread <flags>
-    xptr_t      target_join_lock_xp;    // extended pointer on target thread <join_lock>
-    xptr_t      target_join_xp_xp;      // extended pointer on target thread <join_xp>
-    trdid_t     target_trdid;           // target thread identifier
-    ltid_t      target_ltid;            // target thread local index
-    uint32_t    target_flags;           // target thread flags
-    xptr_t      joining_xp;             // extended pointer on joining thread
-    thread_t  * joining_ptr;            // local pointer on joining thread
-    cxy_t       joining_cxy;            // joining thread cluster
-
-    // get target thread cluster and local pointer
-    target_cxy      = GET_CXY( target_xp );
-    target_ptr      = GET_PTR( target_xp );
-
-    // get target thread trdid, ltid, flags, and process PID
-    target_trdid    = hal_remote_l32( XPTR( target_cxy , &target_ptr->trdid ) );
-    target_ltid     = LTID_FROM_TRDID( target_trdid );
-    target_flags_xp = XPTR( target_cxy , &target_ptr->flags );
-    target_flags    = hal_remote_l32( target_flags_xp );
-    target_process  = hal_remote_lpt( XPTR( target_cxy , &target_ptr->process ) );
-    target_pid      = hal_remote_l32( XPTR( target_cxy , &target_process->pid ) );
-    target_attached = ((target_flags & THREAD_FLAG_DETACHED) == 0); 
-
-    // get killer thread pointers
-    killer_ptr = CURRENT_THREAD;
-    killer_xp  = XPTR( local_cxy , killer_ptr );
-
-#if DEBUG_THREAD_DELETE
-uint32_t cycle  = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_DELETE < cycle )
-printk("\n[%s] killer[%x,%x] enters / target[%x,%x] / forced %d / flags %x / cycle %d\n",
-__FUNCTION__, killer_ptr->process->pid, killer_ptr->trdid,  
-target_pid, target_trdid, is_forced, target_flags, cycle );
-#endif
-
-// check target thread is not the main thread, because the main thread
-// must be deleted by the parent process sys_wait() function
-assert( __FUNCTION__, ((CXY_FROM_PID( target_pid ) != target_cxy) || (target_ltid != 0)),
-"target thread cannot be the main thread" );
-
-    // check killer thread can yield 
-    thread_assert_can_yield( killer_ptr , __FUNCTION__ ); 
-
-    // if the target thread is attached, we must synchonize with the joining thread
-    // before blocking and marking the target thead for delete.
-
-    if( target_attached && (is_forced == false) ) // synchronize with joining thread 
-    {
-        // build extended pointers on target thread join fields
-        target_join_lock_xp  = XPTR( target_cxy , &target_ptr->join_lock );
-        target_join_xp_xp    = XPTR( target_cxy , &target_ptr->join_xp );
-
-        // enter critical section
-        hal_disable_irq( &save_sr );
-
-        // take the join_lock in target thread descriptor
-        remote_busylock_acquire( target_join_lock_xp );
-
-        // get join_done from target thread descriptor
-        target_join_done = ((hal_remote_l32( target_flags_xp ) & THREAD_FLAG_JOIN_DONE) != 0);
-    
-        if( target_join_done )                     // joining thread arrived first
-        {
-            // get extended pointer on joining thread
-            joining_xp  = (xptr_t)hal_remote_l64( target_join_xp_xp );
-
-            // get cluster and local pointer on joining thread
-            joining_ptr = GET_PTR( joining_xp );
-            joining_cxy = GET_CXY( joining_xp );
-
-            // copy exit_status from target thread to joining thread, because
-            // target thread may be deleted before joining thread resume
-            void * status = hal_remote_lpt( XPTR( target_cxy , &target_ptr->exit_status ) );
-            hal_remote_spt( XPTR( joining_cxy , &joining_ptr->exit_status ) , status );
-            
-            // reset the join_done flag in target thread
-            hal_remote_atomic_and( target_flags_xp , ~THREAD_FLAG_JOIN_DONE );
-
-            // unblock the joining thread
-            thread_unblock( joining_xp , THREAD_BLOCKED_JOIN );
-
-            // release the join_lock in target thread descriptor
-            remote_busylock_release( target_join_lock_xp );
-
-            // block the target thread 
-            thread_block( target_xp , THREAD_BLOCKED_GLOBAL );
-
-            // set the REQ_DELETE flag in target thread descriptor
-            hal_remote_atomic_or( target_flags_xp , THREAD_FLAG_REQ_DELETE );
-
-            // exit critical section
-            hal_restore_irq( save_sr );
-
-#if DEBUG_THREAD_DELETE
-cycle  = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_DELETE < cycle )
-printk("\n[%s] killer[%x,%x] exit / target[%x,%x] marked after join / cycle %d\n",
-__FUNCTION__, killer_ptr->process->pid, killer_ptr->trdid,
-target_pid, target_trdid, cycle );
-#endif
-
-        }
-        else                                      // killer thread arrived first
-        {
-            // set the kill_done flag in target thread
-            hal_remote_atomic_or( target_flags_xp , THREAD_FLAG_KILL_DONE );
-
-            // block target thread on BLOCKED_JOIN
-            thread_block( killer_xp , THREAD_BLOCKED_JOIN );
-
-            // set extended pointer on killer thread in target thread
-            hal_remote_s64( target_join_xp_xp , killer_xp );
-
-            // release the join_lock in target thread descriptor
-            remote_busylock_release( target_join_lock_xp );
-
-#if DEBUG_THREAD_DELETE
-cycle  = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_DELETE < cycle )
-printk("\n[%s] killer[%x,%x] deschedules / target[%x,%x] not completed / cycle %d\n",
-__FUNCTION__, killer_ptr->process->pid, killer_ptr->trdid,
-target_pid, target_trdid, cycle );
-#endif
-            // deschedule
-            sched_yield( "killer thread wait joining thread" );
-
-            // block the target thread 
-            thread_block( target_xp , THREAD_BLOCKED_GLOBAL );
-
-            // set the REQ_DELETE flag in target thread descriptor
-            hal_remote_atomic_or( target_flags_xp , THREAD_FLAG_REQ_DELETE );
-
-            // exit critical section
-            hal_restore_irq( save_sr );
-
-#if DEBUG_THREAD_DELETE
-cycle  = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_DELETE < cycle )
-printk("\n[%s] killer[%x,%x] exit / target[%x,%x] marked after join / cycle %d\n",
-__FUNCTION__, killer_ptr->process->pid, killer_ptr->trdid,
-target_pid, target_trdid, cycle );
-#endif
-
-        }
-    }
-    else                     // no synchronization with joining thread required
-    {
-        // block the target thread 
-        thread_block( target_xp , THREAD_BLOCKED_GLOBAL );
-
-        // set the REQ_DELETE flag in target thread descriptor
-        hal_remote_atomic_or( target_flags_xp , THREAD_FLAG_REQ_DELETE );
-
-#if DEBUG_THREAD_DELETE
-cycle  = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_DELETE < cycle )
-printk("\n[%s] killer[%x,%x] exit / target [%x,%x] marked / no join / cycle %d\n",
-__FUNCTION__, killer_ptr->process->pid, killer_ptr->trdid,
-target_pid, target_trdid, cycle );
-#endif
-
-    }
-}  // end thread_delete_request()
-
-
-
-/////////////////////////////
-void thread_idle_func( void )
-{
-
-#if DEBUG_THREAD_IDLE
-uint32_t cycle;
-#endif
-
+/////////////////////////////////////
+void thread_kill( thread_t * target )
+{
+    // set SIG_KILL signal in target thread descriptor
+    thread_set_signal( target , THREAD_SIG_KILL );
+
+    // set the global blocked bit in target thread descriptor.
+    thread_block( target , THREAD_BLOCKED_GLOBAL );
+
+    // send an IPI to reschedule the target thread core.
+    dev_icu_send_ipi( local_cxy , target->core->lid );
+
+}  // end thread_kill()
+
+
+/////////////////////////
+void * thread_idle_func()
+{
     while( 1 )
     {
-        // unmask IRQs
-        hal_enable_irq( NULL );
-
-        // force core to low-power mode (optional)
-        if( CONFIG_SCHED_IDLE_MODE_SLEEP ) 
-        {
-
-#if DEBUG_THREAD_IDLE
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_IDLE < cycle )
-printk("\n[%s] idle thread on core[%x,%d] goes to sleep / cycle %d\n",
-__FUNCTION__, local_cxy, CURRENT_THREAD->core->lid, cycle );
-#endif
-
-            hal_core_sleep();
-
-#if DEBUG_THREAD_IDLE
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_IDLE < cycle )
-printk("\n[%s] idle thread on core[%x,%d] wake up / cycle %d\n",
-__FUNCTION__, local_cxy, CURRENT_THREAD->core->lid, cycle );
-#endif
-
-        }
-
-#if DEBUG_THREAD_IDLE
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_IDLE < cycle )
-sched_remote_display( local_cxy , CURRENT_THREAD->core->lid );
-#endif     
-        // search a runable thread
-        sched_yield( "running idle thread" );
-
-    } // end while
-
+        thread_dmsg("INFO : core %d in cluster %x goes to sleeping state at cycle\n",
+                     core->lid , cluster->cxy, hal_time_stamp() );
+
+        // force core to sleeping state
+        hal_core_sleep();
+
+        thread_dmsg("INFO : core %d in cluster %x wake up at cycle %d\n",
+                     core->lid , cluster->cxy, hal_time_stamp() );
+
+        // force scheduling at wake-up
+        sched_yield();
+   }
 }  // end thread_idle()
 
 
-///////////////////////////////////////////
-void thread_time_update( thread_t * thread,
-                         bool_t     is_user )
-{
-    cycle_t current_cycle;   // current cycle counter value
-    cycle_t last_cycle;      // last cycle counter value
-
-    // get pointer on thread_info structure
-    thread_info_t * info = &thread->info;
-
-    // get last cycle counter value
-    last_cycle = info->last_cycle;
-
-    // get current cycle counter value
-    current_cycle = hal_get_cycles();
-
-    // update thread_info structure
-    info->last_cycle = current_cycle;
-
-    // update time in thread_info
-    if( is_user ) info->usr_cycles += (current_cycle - last_cycle);
-    else          info->sys_cycles += (current_cycle - last_cycle);
-
-}  // end thread_time_update()
-
-/////////////////////////////////////
-xptr_t thread_get_xptr( pid_t    pid,
-                        trdid_t  trdid )
-{
-    cxy_t         target_cxy;          // target thread cluster identifier
-    ltid_t        target_thread_ltid;  // target thread local index
-    thread_t    * target_thread_ptr;   // target thread local pointer
-    xptr_t        target_process_xp;   // extended pointer on target process descriptor
-    process_t   * target_process_ptr;  // local pointer on target process descriptor
-    pid_t         target_process_pid;  // target process identifier
-    xlist_entry_t root;                // root of list of process in target cluster
-    xptr_t        lock_xp;             // extended pointer on lock protecting  this list
-
-#if DEBUG_THREAD_GET_XPTR
-uint32_t cycle  = (uint32_t)hal_get_cycles();
-thread_t * this = CURRENT_THREAD;
-if( DEBUG_THREAD_GET_XPTR < cycle )
-printk("\n[%s] thread %x in process %x enters / pid %x / trdid %x / cycle %d\n",
-__FUNCTION__, this->trdid, this->process->pid, pid, trdid, cycle );
-#endif
-
-    // get target cluster identifier and local thread identifier
-    target_cxy         = CXY_FROM_TRDID( trdid );
-    target_thread_ltid = LTID_FROM_TRDID( trdid );
-
-    // check trdid argument
-	if( (target_thread_ltid >= CONFIG_THREADS_MAX_PER_CLUSTER) || 
-        cluster_is_active( target_cxy ) == false )                return XPTR_NULL;
-
-    // get root of list of process descriptors in target cluster
-    hal_remote_memcpy( XPTR( local_cxy  , &root ),
-                       XPTR( target_cxy , &LOCAL_CLUSTER->pmgr.local_root ),
-                       sizeof(xlist_entry_t) );
-
-    // get extended pointer on lock protecting the list of local processes
-    lock_xp = XPTR( target_cxy , &LOCAL_CLUSTER->pmgr.local_lock );
-
-    // take the lock protecting the list of processes in target cluster
-    remote_queuelock_acquire( lock_xp );
-
-#if( DEBUG_THREAD_GET_XPTR & 1 )
-if( DEBUG_THREAD_GET_XPTR < cycle )
-printk("\n[%s] scan processes in cluster %x :\n", __FUNCTION__, target_cxy );
-#endif
-
-    // scan the list of local processes in target cluster
-    xptr_t  iter;
-    bool_t  found = false;
-    XLIST_FOREACH( XPTR( target_cxy , &LOCAL_CLUSTER->pmgr.local_root ) , iter )
-    {
-        target_process_xp  = XLIST_ELEMENT( iter , process_t , local_list );
-        target_process_ptr = GET_PTR( target_process_xp );
-        target_process_pid = hal_remote_l32( XPTR( target_cxy , &target_process_ptr->pid ) );
-
-#if( DEBUG_THREAD_GET_XPTR & 1 )
-if( DEBUG_THREAD_GET_XPTR < cycle )
-printk(" - process %x\n", target_process_pid );
-#endif
-
-        if( target_process_pid == pid )
-        {
-            found = true;
-            break;
-        }
-    }
-
-    // release the lock protecting the list of processes in target cluster
-    remote_queuelock_release( lock_xp );
-
-    // check PID found
-    if( found == false ) 
-    {
-
-#if( DEBUG_THREAD_GET_XPTR & 1 )
-if( DEBUG_THREAD_GET_XPTR < cycle )
-printk("\n[%s] pid %x not found in cluster %x\n",
-__FUNCTION__, pid, target_cxy );
-#endif
-        return XPTR_NULL;
-    }
-
-    // get target thread local pointer
-    xptr_t xp = XPTR( target_cxy , &target_process_ptr->th_tbl[target_thread_ltid] );
-    target_thread_ptr = (thread_t *)hal_remote_lpt( xp );
-
-    if( target_thread_ptr == NULL )
-    {
-
-#if( DEBUG_THREAD_GET_XPTR & 1 )
-if( DEBUG_THREAD_GET_XPTR < cycle )
-printk("\n[%s] thread %x not registered in process %x in cluster %x\n",
-__FUNCTION__, trdid, pid, target_cxy );
-#endif
-        return XPTR_NULL;
-    }
-
-#if DEBUG_THREAD_GET_XPTR
-cycle  = (uint32_t)hal_get_cycles();
-if( DEBUG_THREAD_GET_XPTR < cycle )
-printk("\n[%s] thread %x in process %x exit / pid %x / trdid %x / cycle %d\n",
-__FUNCTION__, this->trdid, this->process->pid, pid, trdid, cycle );
-#endif
-
-    return XPTR( target_cxy , target_thread_ptr );
-
-}  // end thread_get_xptr()
-
-///////////////////////////////////////////////////
-void thread_assert_can_yield( thread_t    * thread,
-                              const char  * func_str )
-{
-    // does nothing if thread does not hold any busylock
-
-    if( thread->busylocks )
-    {
-        // get pointers on TXT0 chdev
-        xptr_t    txt0_xp  = chdev_dir.txt_tx[0];
-        cxy_t     txt0_cxy = GET_CXY( txt0_xp );
-        chdev_t * txt0_ptr = GET_PTR( txt0_xp );
-
-        // get extended pointer on TXT0 lock
-        xptr_t  txt0_lock_xp = XPTR( txt0_cxy , &txt0_ptr->wait_lock );
-
-        // get TXT0 lock 
-        remote_busylock_acquire( txt0_lock_xp );
-
-        // display error message on TXT0
-        nolock_printk("\n[PANIC] in %s / thread[%x,%x] cannot yield : "
-        "hold %d busylock(s) / cycle %d\n",
-        func_str, thread->process->pid, thread->trdid,
-        thread->busylocks - 1, (uint32_t)hal_get_cycles() );
-
-#if DEBUG_BUSYLOCK_TYPE
-
-// scan list of busylocks
-xptr_t    iter_xp;
-xptr_t    root_xp  = XPTR( local_cxy , &thread->busylocks_root );
-XLIST_FOREACH( root_xp , iter_xp )
-{
-    xptr_t       lock_xp   = XLIST_ELEMENT( iter_xp , busylock_t , xlist );
-    cxy_t        lock_cxy  = GET_CXY( lock_xp );
-    busylock_t * lock_ptr  = GET_PTR( lock_xp );
-    uint32_t     lock_type = hal_remote_l32( XPTR( lock_cxy , &lock_ptr->type ) );
-    nolock_printk(" - %s in cluster %x\n", lock_type_str[lock_type] , lock_cxy );
-}
-
-#endif
-
-        // release TXT0 lock 
-        remote_busylock_release( txt0_lock_xp );
-
-        // suicide
-        hal_core_sleep();
-    }
-}  // end thread_assert_can yield()
-
-//////////////////////////////////////////////////////
-void thread_display_busylocks( xptr_t       thread_xp,
-                               const char * string )
-{
-
-    cxy_t      thread_cxy = GET_CXY( thread_xp );
-    thread_t * thread_ptr = GET_PTR( thread_xp );
-
-#if DEBUG_BUSYLOCK
-
-    xptr_t     iter_xp;
-
-    // get relevant info from target thread descriptor
-    uint32_t    locks   = hal_remote_l32( XPTR( thread_cxy , &thread_ptr->busylocks ) );
-    trdid_t     trdid   = hal_remote_l32( XPTR( thread_cxy , &thread_ptr->trdid ) );
-    process_t * process = hal_remote_lpt( XPTR( thread_cxy , &thread_ptr->process ) );
-    pid_t       pid     = hal_remote_l32( XPTR( thread_cxy , &process->pid ) );
-
-    // get extended pointer on root of busylocks
-    xptr_t root_xp = XPTR( thread_cxy , &thread_ptr->busylocks_root );
-
-    // get pointers on TXT0 chdev
-    xptr_t    txt0_xp  = chdev_dir.txt_tx[0];
-    cxy_t     txt0_cxy = GET_CXY( txt0_xp );
-    chdev_t * txt0_ptr = GET_PTR( txt0_xp );
-
-    // get extended pointer on remote TXT0 lock
-    xptr_t  txt0_lock_xp = XPTR( txt0_cxy , &txt0_ptr->wait_lock );
-
-    // get TXT0 lock 
-    remote_busylock_acquire( txt0_lock_xp );
-
-    // display header 
-    nolock_printk("\n***** thread[%x,%x] in <%s> : %d busylocks *****\n",
-    pid, trdid, string, locks );
-
-    // scan the xlist of busylocks when required
-    if( locks )
-    {
-        XLIST_FOREACH( root_xp , iter_xp )
-        {
-            xptr_t       lock_xp   = XLIST_ELEMENT( iter_xp , busylock_t , xlist );
-            cxy_t        lock_cxy  = GET_CXY( lock_xp );
-            busylock_t * lock_ptr  = GET_PTR( lock_xp );
-            uint32_t     lock_type = hal_remote_l32(XPTR( lock_cxy , &lock_ptr->type ));
-            nolock_printk(" - %s in cluster %x\n", lock_type_str[lock_type] , lock_cxy );
-        }
-    }
-
-    // release TXT0 lock
-    remote_busylock_release( txt0_lock_xp );
-
-#else
-
-printk("\n[ERROR] in %s : set DEBUG_BUSYLOCK in kernel_config.h for %s / thread(%x,%x)\n",
-__FUNCTION__, string, thread_cxy, thread_ptr );
-
-#endif
-
-    return;
-
-}  // end thread_display_busylock()
-
